SystemOrganization addCategory: #ConfigurationOfABTesting!

Object subclass: #ConfigurationOfABTesting
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfABTesting'!

!ConfigurationOfABTesting class methodsFor: 'private' stamp: 'PaulDeBruicker 4/26/2010 14:05'!
bootstrapPackage: aString from: aPath 
	| repository version |
	repository := MCHttpRepository
				location: aPath
				user: ''
				password: ''.
	repository
		versionReaderForFileNamed: aString , '.mcz'
		do: [:reader | 
			version := reader version.
			version load.
			version workingCopy repositoryGroup addRepository: repository]! !

!ConfigurationOfABTesting class methodsFor: 'private' stamp: 'PaulDeBruicker 4/26/2010 14:05'!
ensureMetacello
	"Bootstrap Gofer (if necessary), bootstrap ConfigurationOfMetacello (using old Gofer API), then load the latest 
	version of Metacello itself."

	Smalltalk at: #MetacelloProject ifAbsent: [
		Smalltalk at: #Gofer ifAbsent: [
			"Current version of Gofer from which to bootstrap - as of 1.0-beta.21"
			self bootstrapPackage: 'Gofer-Core-lr.115' from: 'http://seaside.gemstone.com/ss/metacello' ].
		Smalltalk at: #Gofer ifPresent: [:goferClass | | gofer |
			gofer := goferClass new
				url: 'http://seaside.gemstone.com/ss/metacello';
				yourself.
			[ gofer addPackage: 'ConfigurationOfMetacello' ] on: Warning do: [:ex | ex resume ].
			gofer load ].
		"load 'default' group of Metacello"
		(Smalltalk at: #ConfigurationOfMetacello) perform: #load ]! !

!ConfigurationOfABTesting class methodsFor: 'metacello tool support' stamp: 'PaulDeBruicker 4/26/2010 14:05'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfABTesting class methodsFor: 'metacello tool support' stamp: 'PaulDeBruicker 4/26/2010 14:05'!
lastMetacelloVersionLoad
	"Answer the last version loaded and the list of packages loaded for that version."

	LastVersionLoad == nil ifTrue: [ LastVersionLoad := nil -> 'default' ].
	^LastVersionLoad! !

!ConfigurationOfABTesting class methodsFor: 'loading' stamp: 'PaulDeBruicker 4/26/2010 14:05'!
load
	"self load"

	^self project latestVersion load! !

!ConfigurationOfABTesting class methodsFor: 'metacello tool support' stamp: 'PaulDeBruicker 4/26/2010 14:05'!
metacelloVersion: versionString loads: anArrayOrString
	"Stash the last version loaded and the list of packages loaded for that version. The list
	 of packages will be used by the tools when doing 'Load Package Version'"

	LastVersionLoad := versionString -> anArrayOrString! !

!ConfigurationOfABTesting class methodsFor: 'accessing' stamp: 'PaulDeBruicker 4/26/2010 14:05'!
project

	^self new project! !

!ConfigurationOfABTesting class methodsFor: 'unloading Metacello' stamp: 'PaulDeBruicker 4/26/2010 14:05'!
unloadMetacello

	Smalltalk at: #ConfigurationOfMetacello ifPresent: [:cls | cls unloadMetacello ]! !

!ConfigurationOfABTesting methodsFor: 'baselines' stamp: 'PaulDeBruicker 1/28/2011 14:25'!
baseline100: spec 
	<version: '1.0-baseline'>
	
	spec for: #common do: [
		spec blessing: #baseline.
		spec repository: 'http://www.squeaksource.com/ABTesting'.	
		spec	
			project: 'Seaside30' with: [
				spec
					className: 'ConfigurationOfSeaside30';
					versionString: '3.0.3-baseline';
					loads: #('Core');
					file: 'ConfigurationOfSeaside30';
					repository: 'http://www.squeaksource.com/MetacelloRepository'];
			project: 'DHB' with: [
				spec
					className: 'ConfigurationOfDHB';
					versionString: '1.0-baseline';
					loads: #('Core');
					file: 'ConfigurationOfDHB';
					repository: '/home/paul/src/pharoPackages'];	
		yourself.
		
		spec 
			package: 'ABTesting'with:[spec requires: #('DHB' 'Seaside30')].
			
		spec
			group: 'default' with: #('Core');
			group: 'Core' with: #('ABTesting')].! !

!ConfigurationOfABTesting methodsFor: 'accessing' stamp: 'PaulDeBruicker 4/26/2010 14:05'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		self class ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfABTesting methodsFor: 'versions' stamp: 'PaulDeBruicker 1/28/2011 08:11'!
stable: spec

	<symbolicVersion: #'stable'>
	spec for: #'pharo1.1.x' version: '1.1'.
	spec for: #'pharo1.2.x' version: '1.1'.! !

!ConfigurationOfABTesting methodsFor: 'versions' stamp: 'PaulDeBruicker 6/5/2011 17:45'!
version100: spec 
	<version: '1.0' imports: #('1.0-baseline') >
	
	spec for: #common do: [
		spec blessing: #release.
		spec
			project: 'Seaside30' with: '3.0.5';
			project: 'DHB' with: '1.0';	
			yourself.
		spec 
			package: 'ABTesting' with: 'ABTesting-PaulDeBruicker.3'].! !

!ConfigurationOfABTesting methodsFor: 'versions' stamp: 'PaulDeBruicker 4/26/2010 14:09'!
version110: spec 
	<version: '1.1' imports: #('1.0-baseline') >
	
	spec for: #common do: [
		spec blessing: #development.
		spec 
			package: 'ABTesting' with: 'ABTesting-PaulDeBruicker.3'].! !
